#!/bin/bash

buildAll() {
    cd revirt-skas-2.4.18
    make oldconfig
    make dep
    make bzImage

    cd uml
    make

    cd ../../

    cd rlogd
    make

    cd ../zR
    make

    cd ../tunctl
    make

    cd ../uml-2.4.20
    make oldconfig ARCH=um
    make dep ARCH=um
    make linux ARCH=um
    make -f Makefile.stk
}

buildClean() {
    cd revirt-skas-2.4.18
    make clean

    cd uml
    make clean

    cd ../../

    cd rlogd
    make clean

    cd ../zR
    make clean

    cd ../tunctl
    make clean

    cd ../uml-2.4.20
    make clean ARCH=um
    make -f Makefile.stk clean
}

case "$1" in
    all)
	buildAll
	;;
    clean)
	buildClean
	;;
    *)
	echo "Usage {all|clean}"
	exit 1
esac
