#ifndef DBRAW_H__
#define DBRAW_H__

#define DBRAW_INIT_MAP	                _IO( 0xac, 2 )
#define DBRAW_FLUSH_MAP	                _IO( 0xac, 3 )
#define DBRAW_CHECKSUM_HOST_BLOCK	_IO( 0xac, 4 )
#define DBRAW_GET_SIZES	                _IO( 0xac, 5 )
#define DBRAW_RECLAIM_FREE_BLOCKS	_IO( 0xac, 6 )
#define DBRAW_GET_BLOCK_SIZE            _IO( 0xac, 7 )
//#define DBRAW_BLOCK_SIZE 512

struct dbraw_cmd_struct {
  char *buf;
  unsigned long bufSize;
  unsigned long hostAddr;
  unsigned long guestNumBlocks;
};

// all sizes are in blocks;
struct dbraw_size_struct {
  unsigned long blockSize;
  unsigned long numVirt;
  unsigned long numPhys;
  unsigned long numFree;
};

#define COW_DISK_TAKE_CP 0
#define COW_DISK_RESTORE_CP 1
#define COW_DISK_DELETE_CP 2
typedef unsigned long (*cowDiskCpCb)(int action, unsigned long data, 
				     int minor);
extern void registerCowDiskCpCb(cowDiskCpCb cb, int minor);

#endif
