#!/bin/bash
#echo "Turning off syscall checking"
#
#TUN=`tunctl -b`
#ADDR='141.213.8.131'
#
#rm -rf cowfile /root/.uml/* /tmp/uml/*
#echo Using tun device $TUN, address $ADDR
#./start_networking $TUN $ADDR
#TMP=/tmp/uml exec ../zR/log ./linux root=/dev/ubda6 ubda=cowfile,/dev/hda5 con=none con0=null,fd:1 eth0=tuntap,$TUN
#TMP=/tmp/uml ./linux root=/dev/ubda6 ubda=cowfile,/dev/hda5 eth0=tuntap,$TUN

../zR/setopt -12
echo "1" > /proc/sys/kernel/sysrq
rm -rf /tmp/uml/* /root/.uml/*

if [ -z "$HOSTIP" ] ; then
    echo "you must define HOSTIP before starting the virtual machine"
    exit 1
fi

if [ -z "$VMIP" ] ; then
    echo "you must define VMIP before starting the virtual machine"
    exit 1
fi

if [ -z "$UMLHDA" ] ; then
    echo "you must define UMLHDA before starting the virtual machine"
    exit 1
fi

if [ -z "$UMLHDA_ROOT" ] ; then
    echo "you must define UMLHDA_ROOT before starting the virtual machine"
    exit 1
fi

if [ -z "$VMMAC" ] ; then
    echo "you must define VMMAC before starting the virtual machine"
    exit 1
fi

if [ -z "$DBRAW_MAJOR" ] ; then
    echo "you must define DBRAW_MAJOR before starting the virtual machine"
    exit 1
fi

if [ -z "$DBRAW_MINOR" ] ; then
    echo "you must define DBRAW_MINOR before starting the virtual machine"
    exit 1
fi

if [ -z "$DBRAW_NUM_GUEST_BLOCKS" ] ; then
    echo "you must define DBRAW_NUM_GUEST_BLOCKS before starting the virtual machine"
    exit 1
fi

#tunctl -t tap0
#TUN=tap0
echo "staring networking"
TUN=`tunctl -b -m $VMMAC`
./start_networking $TUN $VMIP

LINUXARG=""
if [ "$UMLMEM" != "" ] ; then
    LINUXARG="$LINUXARG mem=$UMLMEM"
fi

#echo "*******the uml device is not loaded, put this back in later!!!!!!!"
#sleep 5
echo "setting up the uml devices"
CWD=`pwd`
cd ../revirt-skas-2.4.18/uml/
./insmoduml
#echo "****************** uml gdb is commented out *********************"
#sleep 5
./insmodumlgdb
echo "initializeng the raw device"
./dbrawctl -s -j $DBRAW_MAJOR -n $DBRAW_MINOR
./dbrawctl -i $DBRAW_NUM_GUEST_BLOCKS -n $DBRAW_MINOR

cd $CWD

rm -f /tmp/cowfile
rm -rf /tmp/uml/* /root/.uml/*
rm -f /tmp/cow-hda*
rm -f /checkpoint/cow-*
#LINUXARG="$LINUXARG root=$UMLHDA_ROOT ubda=/tmp/cowfile,$UMLHDA eth0=tuntap,$TUN"
LINUXARG="$LINUXARG root=$UMLHDA_ROOT ubda=$UMLHDA eth0=tuntap,$TUN panic=10"
#TMP=$TMP $CMDPRE ./linux $LINUXARG
TMP=/tmp/uml $CMDPRE ./linux $LINUXARG

# Sometimes networking doesn't restart right; this seems to fix it.
ifconfig tap0 down
