#!/usr/bin/perl
use strict;

my $EXE_CONF = "exe.conf";
open(EXE_CONF_FILE,"<" . $EXE_CONF) || die("could not open conf file $EXE_CONF");

system("make > /dev/null 2> /dev/null");

my $LINUX_FILE = "../../linux";
system("cp $LINUX_FILE .");

# create plato.conf and guestStructs.h
system("echo -n \"\" > plato.conf");
system("echo -n \"\" > guestStructs.h");

my $line;
my @vals;
my $cmd;
while($line = <EXE_CONF_FILE>) {
    $_ = $line;
    if(/^(\S+[:]\S+)\s*$/) {
	if(substr($1,0,1) ne "#") {
	    @vals = split(/:/,$1);	
	    $cmd = "./gen_exe_data.pl -o " . $vals[0] . " -b " . $vals[1] .
		" -c " . $vals[1] . ".break.conf -g " . $vals[1] .
		".globals.conf -s " . $vals[1] . ".structs.conf";
	    if($vals[2] ne "") {
		$cmd .= " -u " . $vals[2];
	    }
	    print STDERR "executing cmd $cmd\n";
	    system($cmd);
	}
    }
}


system("mv plato.conf ../introspect/");
system("mv guestStructs.h ../introspect/");

