#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>
#include <iostream>

#include "plato.h"
#include "guestStructs.h"

Plato plato;

static unsigned long state = 0;
unsigned long checkIdx;
void myfuncCb() {
  cout << "myfunc " << state << endl;
  if(state == 0) {
    checkIdx = plato.checkpoint();
    state=1;
  } else if(state == 1) {
    plato.rollback(checkIdx);
    state=2;
  } else if(state == 2)
    state=0;

}

//void otherfuncCb() {
//cout << "otherfunc" << endl;
//}

void initCb() {
  cout << "init user mode callbacks" << endl;
  plato.registerBreak("myfunc:1:begin",myfuncCb);
  //plato.registerBreak("otherfunc:1:begin",otherfuncCb);
}  

int main(int argc, char *argv[]) {
  plato.init("plato.conf");
  plato.startEventLoop(initCb);
  return 0;
}
