#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "asm/unistd.h"
#include "revirt/ztrace.h"

#include "library.h"

int main(int argc, char *argv[]) {
  unsigned long markerNo;
  int ret;

  if(argc != 2) {
    printf("usage:ztrace_marker markerNo\n");
    return -1;
  }

  ret = sscanf(argv[1],"%lu",&markerNo);
  if(ret != 1) {
    printf("could not parse marker number\n");
    return -1;
  }

  ztrace(ZTRACE_MARKER, markerNo, 0, 0);
  
  return 0;
}
