#include <linux/config.h>
#include <linux/slab.h>
#include <linux/init.h>
#include <linux/unistd.h>
#include <linux/smp_lock.h>
#include <linux/module.h>
#include <linux/vmalloc.h>
#include <linux/completion.h>
#include <linux/namespace.h>
#include <linux/personality.h>
#include <linux/compiler.h>

#include <asm/pgtable.h>
#include <asm/pgalloc.h>
#include <asm/uaccess.h>
#include <asm/mmu_context.h>
#include <asm/io.h>

static unsigned long stk_mem0 = 0;
static unsigned long stk_mem1 = 1;
static unsigned long stk_mem2 = 2;

void sys_stk_syscall(int numIter) {
	unsigned long idx;
	int tmp;
	/*
	  unsigned long pidOffset;
	  pid_t pid;
	  unsigned long myesp;
	  
	  //myesp = inb(0x3e);
	  __asm__("andl %%esp,%0; ":"=r" (myesp) : "0" (~8191UL));
	  
	  pidOffset = ((unsigned long) &current->pid) - ((unsigned long) current);
	  printk("this is the stk system call\n");
	  
	  printk("esp 0x%08lx current 0x%08lx, pid = %d, pidOffset = %lu, pidAddr 0x%08lx\n",
	  myesp, (unsigned long) current, current->pid, pidOffset,
	  (unsigned long) &(current->pid));
	*/
	
	//printk("calling %d inb's...\n",numIter);
	
	printk("numIter = %d\n",numIter);
	
	for(idx = 0; idx < numIter; idx++) {
		stk_mem0 += idx;
		stk_mem1 += idx+1;
		stk_mem2 += idx+2;
		
		//tmp = inb(0x2f8);
	}
	
	return;
}
