#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>
#include <iostream>
#include <fstream>

#include "plato.h"
#include "guestStructs.h"

#include <sys/types.h>
#include <sys/time.h>

#include <errno.h>

#include <fcntl.h>

Plato plato;

void getpidCb() {
  cout << "getpid cb" << endl;
}

void initCb() {
  cout << "initCb" << endl;
  plato.registerBreak("sys_getpid:1:end",getpidCb);
}  

int main(int argc, char *argv[]) {
  plato.init("plato.conf");

  plato.startEventLoop(initCb);

  return 0;
}
