#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>
#include <iostream>

#include "plato.h"
#include "guestStructs.h"

Plato plato;

void overflow1Cb() {
  cout << "beginning of overflow1Cb" << endl;
  unsigned long bufsize = plato.readVar("bufsize");
  unsigned long slen2 = plato.readVar("slen2");
  //int bufsize = 32;
  //int slen2 = 36;
  cout << "bufsize: " << bufsize << " slen2: " << slen2 << endl;
  if (slen2 >= bufsize) {
    cout << "buffer overflow bug triggered" << endl;
  } else {
    cout << "buffer overflow bug not triggered" << endl;
  }
  cout << "end of overflow1Cb" << endl;
}
/*
void overflow2Cb() {
  cout << "beginning of overflow2Cb" << endl;
  int bufsize = plato.readVar("bufsize");
  int slen3 = plato.readVar("slen3");
  cout << "bufsize: " << bufsize << " slen3: " << slen3 << endl;
  if (slen3 >= bufsize) {
    cout << "buffer overflow bug triggered" << endl;
  } else {
    cout << "buffer overflow bug not triggered" << endl;
  }
  cout << "end of overflow2Cb" << endl;
}
*/
void initCb() {
  cout << "init user mode callbacks" << endl;
  plato.registerBreak("overflow:1:begin",overflow1Cb);
//  plato.registerBreak("overflow:2:begin",overflow2Cb);
}  

int main(int argc, char *argv[]) {
  plato.init("plato.conf");
  plato.startEventLoop(initCb);
  return 0;
}
