#!/bin/bash

if [ -z "$UMLHDA" ] ; then
    echo "you must define UMLHDA before starting the virtual machine"
    exit 1
fi

if [ -z "$UMLHDA_ROOT" ] ; then
    echo "you must define UMLHDA_ROOT before starting the virtual machine"
    exit 1
fi

if [ -z "$DBRAW_MAJOR" ] ; then
    echo "you must define DBRAW_MAJOR before starting the virtual machine"
    exit 1
fi

if [ -z "$DBRAW_MINOR" ] ; then
    echo "you must define DBRAW_MINOR before starting the virtual machine"
    exit 1
fi

if [ -z "$DBRAW_NUM_GUEST_BLOCKS" ] ; then
    echo "you must define DBRAW_NUM_GUEST_BLOCKS before starting the virtual machine"
    exit 1
fi

cd ../revirt-skas-2.4.18/uml
./insmoduml
./insmodumlgdb
./dbrawctl -s -j $DBRAW_MAJOR -n $DBRAW_MINOR
./dbrawctl -i $DBRAW_NUM_GUEST_BLOCKS -n $DBRAW_MINOR
cd ../../uml-2.4.20
./linux root=$UMLHDA_ROOT ubda=$UMLHDA con=pts con0=fd:0,fd:1 con1=tty:/dev/tty7 single

echo "Don't forget to dbrawctl -f if you want to keep changes"
