#!/bin/bash
echo "Turning off syscall checking"
../zR/setopt -12
../zR/setopt +25
echo "1" > /proc/sys/kernel/sysrq
rm -rf cowfile /root/.uml/* /tmp/uml/*

if [ -z "$DBRAW_MAJOR" ] ; then
    echo "you must define DBRAW_MAJOR before starting the virtual machine"
    exit 1
fi

if [ -z "$DBRAW_MINOR" ] ; then
    echo "you must define DBRAW_MINOR before starting the virtual machine"
    exit 1
fi

if [ -z "$DBRAW_NUM_GUEST_BLOCKS" ] ; then
    echo "you must define DBRAW_NUM_GUEST_BLOCKS before starting the virtual machine"
    exit 1
fi

#echo "*******the uml device is not loaded, put this back in later!!!!!!!"
#sleep 5
echo "setting up the uml devices"
CWD=`pwd`
cd ../revirt-skas-2.4.18/uml/
./insmoduml
#echo "****************** uml gdb is commented out *********************"
#sleep 5
./insmodumlgdb

echo "initializeng the raw device"
./dbrawctl -s -j $DBRAW_MAJOR -n $DBRAW_MINOR
./dbrawctl -i $DBRAW_NUM_GUEST_BLOCKS -n $DBRAW_MINOR

cd $CWD

rm -f /tmp/cowfile
rm -rf /tmp/uml/* /root/.uml/*
rm -f /tmp/cow-hda*
rm -f /checkpoint/cow-*


TMP=/tmp/uml exec ../zR/rexec /tmp/rlog &

echo "looking for the linux pid"

LINUXPID=`pidof linux`
while [ -z "$LINUXPID" ] ; do
    sleep 1
    LINUXPID=`pidof linux`
done

sleep 5

echo "starting zr $1 $2"
../zR/zr $LINUXPID /tmp/rlog 0 $1 $2 >& /tmp/zr &


echo "looking for the zr pid"
ZRPID=`pidof zr`
while [ -z "$ZRPID" ] ; do
    sleep 1
    ZRPID=`pidof zr`
done

echo "waiting for rexec to shut down"
wait `pidof rexec`

echo "waiting for zr to shut down"
wait $ZRPID

#echo "Restoring the disk"
#./resetDisk.pl

echo "replay done"
