#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <asm/unistd.h>

#include <linux/autoconf.h>
#include <revirt/rlog.h>
#include <revirt/ztrace.h>
#include <revirt/syscalls.h>

#include "library.h"

/* FIXME -- just for now */
#define ZTRACE_GETSTATE 8

int main(int argc, char * argv[]) {
	struct ztrace_state_struct zt_state;
	int pid;
	zt_state.regs.edx = 0xcafe0000;
	if(argc < 2) {
		fprintf(stderr, "Usage: %s pid\n", argv[0]);
		exit(1);
	}
	pid=atoi(argv[1]);
	if(ztrace(ZTRACE_GETSTATE, pid,0,&zt_state)) {
		perror("getstate");
	}
	print_state(&zt_state);
	return(0);
}
