#ifndef __LIB_CHECKPOINT_H
#define __LIB_CHECKPOINT_H
#include "uml.h"

extern int umlfd;
extern int first_cid;
extern int nr_checkpoints;
extern int count_deleted_blocks;
long long deleted_checkpoint_blocks;
struct uml_ioc_checkinfo_struct checkpoint_list[MAX_UML_CHECK];


int ztrace_waitevent(int cmd, int mark);
int waitevent_enable(int enable) ;
int waitevent_marker(int mark) ;
int waitevent_wait(void) ;
int waitevent_cont(void);
int waitevent_is_waiting(void) ;

long long dbraw_free_space(void);
int dbraw_reclaim(void);

int open_umlfd(void);
void print_checkpoint(struct uml_ioc_checkinfo_struct *cis) ;
void print_checkpoint_list(void) ;
int get_checkpoint_list(void) ;
int get_current_info(struct uml_ioc_checkinfo_struct * cur) ;
int delete_checkpoint(int checkId) ;
int take_checkpoint(void) ;
int take_checkpoint_d(void) ;
int restore_checkpoint(int checkId) ;
int wait_checkpoint_interval(int interval) ;
int take_checkpoints(int interval, int checkpoints) ;
int find_current_checkpoint(int sid) ;
void delete_additional_checkpoints() ;
void setup_stuff();
void cleanup_stuff(void);
void cleanup_intermediate(void);
long long get_free_blocks(void);

#endif
