#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>

#include <revirt/ztrace.h>
#include <revirt/wraw.h>

#include "library.h"

int main(int argc, char * argv[]) {
	int fd;

	if(argc < 2) {
		fprintf(stderr ,"Usage: %s [wrawdev]\n", argv[0]);
		exit(1);
	}
	
	if(argc == 2) {
		if((fd=open(argv[1], O_RDONLY))<0) {
			perror("open");
			exit(1);
		}
		if(ioctl(fd, WRAW_RELEASE)<0) {
			perror("ioctl WRAW_RELEASE");
			fprintf(stderr, "errno: %d\n", errno);
			exit(1);
		}
	}
	close(fd);
	return 0;
}
